/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
void KbfxConfigDlgButton::init()
{    
	connect( this, SIGNAL(KbfxConfigDlgButtonChanged(const char *, const QString &)), this, SLOT(ChangeForm( const char *, const QString &)) );
}


// Actions performed when URL is selected
void KbfxConfigDlgButton::KbfxURLRequesterNormalUrlSelected( const QString & selected_img_path )
{
    emit KbfxConfigDlgButtonChanged("normal", selected_img_path);
    kdDebug() << "Sending: normal + " << selected_img_path << endl;
}

void KbfxConfigDlgButton::KbfxURLRequesterPressedUrlSelected( const QString & selected_img_path)
{
    emit KbfxConfigDlgButtonChanged("pressed", selected_img_path);
    kdDebug() << "Sending: pressed + " << selected_img_path << endl;
}

void KbfxConfigDlgButton::KbfxURLRequesterHoverUrlSelected( const QString & selected_img_path)
{
    emit KbfxConfigDlgButtonChanged("hover", selected_img_path);
    kdDebug() << "Sending: hover + " << selected_img_path << endl;
}


void KbfxConfigDlgButton::KbfxButtonToggled( bool )
{
    if ( KbfxButton->state() == 2 )
    {
        KbfxButton->setPixmap(ConfigInit().m_KbfxPressedButtonPath);
    }
    if ( KbfxButton->state() == 0 )
    {
        KbfxButton->setPixmap(ConfigInit().m_KbfxNormalButtonPath);
    }
}


// URL processing 
void KbfxConfigDlgButton::ChangeForm( const char * name, const QString & path )
{
    kdDebug() << "Received: "  << name << " + " << path << endl;
	
	QString tmpname=name;
	QString tmppath=path;
	if( tmppath.startsWith( "file://" ) )
	{
		tmppath.remove( "file://" );
	}
    
    QImage tmp (tmppath);

    
    if ( tmpname == "pressed" )
    {
		if (tmp.isNull ())
		    {
				KMessageBox::error(0, tr2i18n("Image cannot be used as a Pressed button Skin!\nWill use Default Pressed button Skin."), tr2i18n("Error Loading Image"));
				tmppath = ConfigInit().m_KbfxPressedButtonPathDefault;
		    }
	    kdDebug() << tmpname << " :: " << tmppath << endl;
		KbfxURLRequesterPressed->setURL(tmppath);
		KbfxPixmapLabelPressed->setPixmap(tmppath);
		ConfigInit().m_KbfxPressedButtonPath=tmppath;
		if ( KbfxButton->state() == 2 )
		{
			KbfxButton->setPixmap(ConfigInit().m_KbfxPressedButtonPath);
		}
	}
		
    if ( tmpname == "normal" )
    {
		if (tmp.isNull ())
		    {
				KMessageBox::error(0, tr2i18n("Image cannot be used as a Normal button Skin!\nWill use Default Normal button Skin."), tr2i18n("Error Loading Image"));
				tmppath = ConfigInit().m_KbfxNormalButtonPathDefault;
		    }
		kdDebug() << tmpname << " :: "  << tmppath << endl;
		KbfxURLRequesterNormal->setURL(tmppath);
		KbfxPixmapLabelNormal->setPixmap(tmppath);
		ConfigInit().m_KbfxNormalButtonPath=tmppath;
		if ( KbfxButton->state() == 0 )
		{
			KbfxButton->setPixmap(ConfigInit().m_KbfxNormalButtonPath);
		}
	}
		
    if ( tmpname == "hover" )
    {
		if (tmp.isNull ())
		    {
				KMessageBox::error(0, tr2i18n("Image cannot be used as a Hover button Skin!\nWill use Default Hover button Skin."), tr2i18n("Error Loading Image"));
				tmppath = ConfigInit().m_KbfxHoverButtonPathDefault;
		    }
		kdDebug() << tmpname << " :: " << tmppath << endl;
		KbfxURLRequesterHover->setURL(tmppath);
		KbfxPixmapLabelHover->setPixmap(tmppath);
		ConfigInit().m_KbfxHoverButtonPath=tmppath;
	}

}


// Init the KBFX Button Page at the beginning or after "Default" pressed
void KbfxConfigDlgButton::ChangeForm()
{
    KbfxURLRequesterNormal->setURL(ConfigInit().m_KbfxNormalButtonPath);
    KbfxURLRequesterPressed->setURL(ConfigInit().m_KbfxPressedButtonPath);
    KbfxURLRequesterHover->setURL(ConfigInit().m_KbfxHoverButtonPath);
	KbfxPixmapLabelNormal->setPixmap(ConfigInit().m_KbfxNormalButtonPath);
	KbfxPixmapLabelPressed->setPixmap(ConfigInit().m_KbfxPressedButtonPath);
	KbfxPixmapLabelHover->setPixmap(ConfigInit().m_KbfxHoverButtonPath);
	KbfxButtonToggled(1);
}
